--- //depot/vendor/freebsd/src/sys/rpc/rpcclnt.c	2004/03/07 08:25:23
+++ //depot/user/rwatson/netperf/sys/rpc/rpcclnt.c	2004/03/07 09:40:54
@@ -362,7 +362,7 @@
 		RPC_RETURN(EFAULT);
 	}
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/* create the socket */
 	rpc->rc_so = NULL;
@@ -620,7 +620,7 @@
 {
 	struct socket  *so;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rpc->rc_so) {
 		so = rpc->rc_so;
@@ -671,7 +671,7 @@
 #endif
 	int error, soflags, flags;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	if (rep) {
 		if (rep->r_flags & R_SOFTTERM) {
@@ -756,7 +756,7 @@
 #endif
 	int error, sotype, rcvflg;
 
-	GIANT_REQUIRED;		/* XXX until socket locking done */
+	NET_ASSERT_GIANT();
 
 	/*
 	 * Set up arguments for soreceive()
@@ -1436,6 +1436,7 @@
 		 * Set r_rtt to -1 in case we fail to send it now.
 		 */
 		rep->r_rtt = -1;
+		SOCKBUF_LOCK(&so->so_snd);
 		if (sbspace(&so->so_snd) >= rep->r_mreq->m_pkthdr.len &&
 		    ((rpc->rc_flag & RPCCLNT_DUMBTIMR) ||
 		     (rep->r_flags & R_SENT) ||
@@ -1470,6 +1471,7 @@
 				rep->r_rtt = 0;
 			}
 		}
+		SOCKBUF_UNLOCK(&so->so_snd);
 	}
 	splx(s);
 
--- //depot/vendor/freebsd/src/sys/sys/mutex.h	2004/03/01 14:38:06
+++ //depot/user/rwatson/netperf/sys/sys/mutex.h	2004/03/05 07:52:54
@@ -350,19 +350,22 @@
  * without special recursion handling.
  *
  * This mechanism is intended as temporary until everything of
- * importance is properly locked.
+ * importance is properly locked.  Note: the semantics for
+ * NET_{LOCK,UNLOCK}_GIANT() are not the same as DROP_GIANT()
+ * and PICKUP_GIANT(), as they are plain mutex operations
+ * without a recursion counter.
  */
 extern	int debug_mpsafenet;		/* defined in net/netisr.c */
 #define	NET_LOCK_GIANT() do {						\
-	if (debug_mpsafenet)						\
+	if (!debug_mpsafenet)						\
 		mtx_lock(&Giant);					\
 } while (0)
 #define	NET_UNLOCK_GIANT() do {						\
-	if (debug_mpsafenet)						\
+	if (!debug_mpsafenet)						\
 		mtx_unlock(&Giant);					\
 } while (0)
 #define	NET_ASSERT_GIANT() do {						\
-	if (debug_mpsafenet)						\
+	if (!debug_mpsafenet)						\
 		mtx_assert(&Giant, MA_OWNED);				\
 } while (0)
 
--- //depot/vendor/freebsd/src/sys/sys/socketvar.h	2004/02/29 19:15:33
+++ //depot/user/rwatson/netperf/sys/sys/socketvar.h	2004/02/29 21:00:26
@@ -39,6 +39,8 @@
 
 #include <sys/queue.h>			/* for TAILQ macros */
 #include <sys/selinfo.h>		/* for struct selinfo */
+#include <sys/_lock.h>
+#include <sys/_mutex.h>
 
 /*
  * Kernel structure per socket.
@@ -48,19 +50,6 @@
  */
 typedef	u_quad_t so_gen_t;
 
-/*
- * List of locks:
- * (c)	const, inited in either socreate() or sonewconn()
- * (m)	sb_mtx mutex
- * (mr)	so_rcv.sb_mtx mutex
- * (sg)	sigio_lock sx
- * (sh)	sohead_lock sx
- *
- * Lock of so_rcv.sb_mtx can duplicate, provided that sohead_lock
- * is exclusively locked.
- *
- * Brackets mean that this data is not protected yet.
- */
 struct socket {
 	int	so_count;		/* reference count */
 	short	so_type;		/* generic type, see socket.h */
@@ -99,6 +88,7 @@
  */
 	struct sockbuf {
 		struct	selinfo sb_sel;	/* process selecting read/write */
+		struct	mtx sb_mtx;	/* sockbuf lock */
 #define	sb_startzero	sb_mb
 		struct	mbuf *sb_mb;	/* the mbuf chain */
 		struct	mbuf *sb_mbtail; /* the last mbuf in the chain */
@@ -146,6 +136,22 @@
 	}								\
 } while (/*CONSTCOND*/0)
 
+#define	SOCKBUF_MTX(_sb)		(&(_sb)->sb_mtx)
+#define	SOCKBUF_LOCK_INIT(_sb, _name) \
+	mtx_init(SOCKBUF_MTX(_sb), _name, NULL, MTX_DEF)
+#define	SOCKBUF_LOCK_DESTROY(_sb)	mtx_destroy(SOCKBUF_MTX(_sb))
+#define	SOCKBUF_LOCK(_sb)		mtx_lock(SOCKBUF_MTX(_sb))
+#define	SOCKBUF_OWNED(_sb)		mtx_owned(SOCKBUF_MTX(_sb))
+#define	SOCKBUF_UNLOCK(_sb)		mtx_unlock(SOCKBUF_MTX(_sb))
+#define	SOCKBUF_LOCK_ASSERT(_sb)	mtx_assert(SOCKBUF_MTX(_sb), MA_OWNED)
+
+/* NB: we reuse the rcv sockbuf's lock for other items in the socket */
+#define	SOCK_MTX(_so)			SOCKBUF_MTX(&(_so)->so_rcv)
+#define	SOCK_LOCK(_so)			SOCKBUF_LOCK(&(_so)->so_rcv)
+#define	SOCK_OWNED(_so)			SOCKBUF_OWNED(&(_so)->so_rcv)
+#define	SOCK_UNLOCK(_so)		SOCKBUF_UNLOCK(&(_so)->so_rcv)
+#define	SOCK_LOCK_ASSERT(_so)		SOCKBUF_LOCK_ASSERT(&(_so)->so_rcv)
+
 /*
  * Socket state bits.
  */
@@ -197,6 +203,7 @@
 	uid_t	so_uid;		/* XXX */
 };
 
+#ifdef _KERNEL
 /*
  * Macros for sockets and socket buffering.
  */
@@ -267,47 +274,61 @@
 		((sb)->sb_flags |= SB_LOCK), 0)
 
 /* release lock on sockbuf sb */
-#define	sbunlock(sb) { \
+#define	sbunlock(sb) do { \
 	(sb)->sb_flags &= ~SB_LOCK; \
 	if ((sb)->sb_flags & SB_WANT) { \
 		(sb)->sb_flags &= ~SB_WANT; \
 		wakeup(&(sb)->sb_flags); \
 	} \
-}
+} while (0)
 
 /*
  * soref()/sorele() ref-count the socket structure.  Note that you must
  * still explicitly close the socket, but the last ref count will free
  * the structure.
  */
-#define soref(so)	do {			\
-				++(so)->so_count; \
-			} while (0)
+#define soref(so) do {					\
+	++(so)->so_count;				\
+} while (0)
 
-#define sorele(so)	do {				\
-				if ((so)->so_count <= 0)	\
-					panic("sorele");\
-				if (--(so)->so_count == 0)\
-					sofree(so);	\
-			} while (0)
+#define sorele(so) do {					\
+	SOCK_LOCK_ASSERT(so);				\
+	if ((so)->so_count <= 0)			\
+		panic("sorele");			\
+	if (--(so)->so_count == 0)			\
+		sofree(so);				\
+	else						\
+		SOCK_UNLOCK(so);			\
+	so = NULL;					\
+} while (0)
 
-#define sotryfree(so)	do {				\
-				if ((so)->so_count == 0)	\
-					sofree(so);	\
-			} while(0)
+#define sotryfree(so) do {				\
+	SOCK_LOCK_ASSERT(so);				\
+	if ((so)->so_count == 0)			\
+		sofree(so);				\
+	else						\
+		SOCK_UNLOCK(so);			\
+	so = NULL;					\
+} while (0)
 
-#define	sorwakeup(so)	do {					\
-				if (sb_notify(&(so)->so_rcv))	\
-					sowakeup((so), &(so)->so_rcv); \
-			} while (0)
+#define	sorwakeup(so) do {				\
+	if (sb_notify(&(so)->so_rcv))			\
+		sowakeup((so), &(so)->so_rcv);		\
+} while (0)
+#define	sorwakeup_locked(so) do {			\
+	if (sb_notify(&(so)->so_rcv))			\
+		sowakeup_locked((so), &(so)->so_rcv);	\
+} while (0)
 
-#define	sowwakeup(so)	do {					\
-				if (sb_notify(&(so)->so_snd))	\
-					sowakeup((so), &(so)->so_snd); \
-			} while (0)
+#define	sowwakeup(so) do {				\
+	if (sb_notify(&(so)->so_snd))			\
+		sowakeup((so), &(so)->so_snd);		\
+} while (0)
+#define	sowwakeup_locked(so)	do {			\
+	if (sb_notify(&(so)->so_snd))			\
+		sowakeup_locked((so), &(so)->so_snd);	\
+} while (0)
 
-#ifdef _KERNEL
-
 /*
  * Argument structure for sosetopt et seq.  This is in the KERNEL
  * section because it will never be visible to user code.
@@ -355,12 +376,19 @@
 int	sockargs(struct mbuf **mp, caddr_t buf, int buflen, int type);
 int	getsockaddr(struct sockaddr **namp, caddr_t uaddr, size_t len);
 void	sbappend(struct sockbuf *sb, struct mbuf *m);
+void	sbappend_locked(struct sockbuf *sb, struct mbuf *m);
 void	sbappendstream(struct sockbuf *sb, struct mbuf *m);
+void	sbappendstream_locked(struct sockbuf *sb, struct mbuf *m);
 int	sbappendaddr(struct sockbuf *sb, struct sockaddr *asa,
 	    struct mbuf *m0, struct mbuf *control);
+int	sbappendaddr_locked(struct sockbuf *sb, struct sockaddr *asa,
+	    struct mbuf *m0, struct mbuf *control);
 int	sbappendcontrol(struct sockbuf *sb, struct mbuf *m0,
 	    struct mbuf *control);
+int	sbappendcontrol_locked(struct sockbuf *sb, struct mbuf *m0,
+	    struct mbuf *control);
 void	sbappendrecord(struct sockbuf *sb, struct mbuf *m0);
+void	sbappendrecord_locked(struct sockbuf *sb, struct mbuf *m0);
 void	sbcheck(struct sockbuf *sb);
 void	sbcompress(struct sockbuf *sb, struct mbuf *m, struct mbuf *n);
 struct mbuf *
@@ -369,6 +397,7 @@
 void	sbdroprecord(struct sockbuf *sb);
 void	sbflush(struct sockbuf *sb);
 void	sbinsertoob(struct sockbuf *sb, struct mbuf *m0);
+void	sbinsertoob_locked(struct sockbuf *sb, struct mbuf *m0);
 void	sbrelease(struct sockbuf *sb, struct socket *so);
 int	sbreserve(struct sockbuf *sb, u_long cc, struct socket *so,
 	    struct thread *td);
@@ -381,7 +410,9 @@
 int	socheckuid(struct socket *so, uid_t uid);
 int	sobind(struct socket *so, struct sockaddr *nam, struct thread *td);
 void	socantrcvmore(struct socket *so);
+void	socantrcvmore_locked(struct socket *so);
 void	socantsendmore(struct socket *so);
+void	socantsendmore_locked(struct socket *so);
 int	soclose(struct socket *so);
 int	soconnect(struct socket *so, struct sockaddr *nam, struct thread *td);
 int	soconnect2(struct socket *so1, struct socket *so2);
@@ -422,6 +453,7 @@
 int	soshutdown(struct socket *so, int how);
 void	sotoxsocket(struct socket *so, struct xsocket *xso);
 void	sowakeup(struct socket *so, struct sockbuf *sb);
+void	sowakeup_locked(struct socket *so, struct sockbuf *sb);
 
 #ifdef SOCKBUF_DEBUG
 void	sblastrecordchk(struct sockbuf *, const char *, int);
--- //depot/vendor/freebsd/src/sys/sys/unpcb.h	2003/02/05 17:35:25
+++ //depot/user/rwatson/netperf/sys/sys/unpcb.h	2004/02/28 14:29:37
@@ -82,6 +82,7 @@
 	unp_gen_t unp_gencnt;		/* generation count of this instance */
 	int	unp_flags;		/* flags */
 	struct	xucred unp_peercred;	/* peer credentials, if applicable */
+	struct	mtx unp_mtx;		/* locking */
 };
 
 /*
